class ListCommonMedia {
  List<CommonMedia>? items;
  int? totalItems;
  int? numberOfPages;

  ListCommonMedia({this.items, this.totalItems, this.numberOfPages});

  ListCommonMedia.fromJson(Map<String, dynamic> json) {
    if (json["items"] is List) {
      items = json["items"] == null
          ? null
          : (json["items"] as List)
              .map((e) => CommonMedia.fromJson(e))
              .toList();
    }
    if (json["totalItems"] is int) {
      totalItems = json["totalItems"];
    }
    if (json["numberOfPages"] is int) {
      numberOfPages = json["numberOfPages"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    if (items != null) {
      _data["items"] = items?.map((e) => e.toJson()).toList();
    }
    _data["totalItems"] = totalItems;
    _data["numberOfPages"] = numberOfPages;
    return _data;
  }
}

class CommonMedia {
  int? id;
  dynamic url;
  dynamic compressedUrl;
  dynamic superCompressedUrl;
  dynamic label;
  dynamic whisePictureId;
  dynamic catId;
  dynamic purpose;

  String? get smallPic => compressedUrl ?? url;

  String? get tinyUrl => superCompressedUrl ?? compressedUrl ?? url;

  CommonMedia(
      {this.id,
      this.url,
      this.compressedUrl,
      this.superCompressedUrl,
      this.label,
      this.whisePictureId,
      this.catId,
      this.purpose});

  CommonMedia.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    url = json["url"];
    compressedUrl = json["compressedUrl"];
    superCompressedUrl = json["superCompressedUrl"];
    label = json["label"];
    whisePictureId = json["whisePictureId"];
    catId = json["catId"];
    purpose = json["purpose"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["url"] = url;
    data["compressedUrl"] = compressedUrl;
    data["superCompressedUrl"] = superCompressedUrl;
    data["label"] = label;
    data["whisePictureId"] = whisePictureId;
    data["catId"] = catId;
    data["purpose"] = purpose;
    return data;
  }
}
