import 'platform_user_detail.dart';

class PlatformUserList {
  int? totalNumberOfUsers;
  List<PlatformUserDetail>? users;

  PlatformUserList({this.totalNumberOfUsers, this.users});

  PlatformUserList.fromJson(Map<String, dynamic> json) {
    if (json["totalNumberOfUsers"] is int) {
      totalNumberOfUsers = json["totalNumberOfUsers"];
    }
    if (json["users"] is List) {
      users = json["users"] == null
          ? null
          : (json["users"] as List)
              .map((e) => PlatformUserDetail.fromJson(e))
              .toList();
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["totalNumberOfUsers"] = totalNumberOfUsers;
    if (users != null) {
      data["users"] = users?.map((e) => e.toJson()).toList();
    }
    return data;
  }
}
