import 'package:_private_core_network/network_resources/resources.dart';
import 'package:_private_core_network/utils.dart';
import 'package:dio/dio.dart';

import 'models/country_available.dart';

class MyAppEndpoint {
  MyAppEndpoint._();
  static String getcountriesAvailableByKeyword() =>
      "v2/country/getcountriesAvailableByKeyword";
  static String getCurrencyOfCountry() => "v2/country/getCurrencyOfCountry";
}

abstract class MyAppApi {
  Future<NetworkResponse> getcountriesAvailableByKeyword(params);
  Future<NetworkResponse> getCurrencyOfCountry(params);
}

class MyAppApiImp extends MyAppApi {
  @override
  Future<NetworkResponse> getcountriesAvailableByKeyword(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            MyAppEndpoint.getcountriesAvailableByKeyword(),
            queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => CountryAvailable.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getCurrencyOfCountry(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .get(MyAppEndpoint.getCurrencyOfCountry(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => CurrencyAvailable.fromJson(json));
      },
    );
  }
}
