class SeachPlaceResultModel {
  String? businessStatus;
  String? formattedAddress;
  Geometry? geometry;
  String? icon;
  String? iconBackgroundColor;
  String? iconMaskBaseUri;
  String? name;
  OpeningHours? openingHours;
  List<Photos>? photos;
  String? placeId;
  PlusCode? plusCode;
  int? priceLevel;
  double? rating;
  String? reference;
  List<String>? types;
  int? userRatingsTotal;

  SeachPlaceResultModel(
      {this.businessStatus,
      this.formattedAddress,
      this.geometry,
      this.icon,
      this.iconBackgroundColor,
      this.iconMaskBaseUri,
      this.name,
      this.openingHours,
      this.photos,
      this.placeId,
      this.plusCode,
      this.priceLevel,
      this.rating,
      this.reference,
      this.types,
      this.userRatingsTotal});

  SeachPlaceResultModel.fromJson(Map<String, dynamic> json) {
    if (json["business_status"] is String) businessStatus = json["business_status"];
    if (json["formatted_address"] is String) formattedAddress = json["formatted_address"];
    if (json["geometry"] is Map) {
      geometry = json["geometry"] == null ? null : Geometry.fromJson(json["geometry"]);
    }
    if (json["icon"] is String) icon = json["icon"];
    if (json["icon_background_color"] is String) {
      iconBackgroundColor = json["icon_background_color"];
    }
    if (json["icon_mask_base_uri"] is String) iconMaskBaseUri = json["icon_mask_base_uri"];
    if (json["name"] is String) name = json["name"];
    if (json["opening_hours"] is Map) {
      openingHours =
          json["opening_hours"] == null ? null : OpeningHours.fromJson(json["opening_hours"]);
    }
    if (json["photos"] is List) {
      photos = json["photos"] == null
          ? null
          : (json["photos"] as List).map((e) => Photos.fromJson(e)).toList();
    }
    if (json["place_id"] is String) placeId = json["place_id"];
    if (json["plus_code"] is Map) {
      plusCode = json["plus_code"] == null ? null : PlusCode.fromJson(json["plus_code"]);
    }
    if (json["price_level"] is int) priceLevel = json["price_level"];
    if (json["rating"] is double) rating = json["rating"];
    if (json["reference"] is String) reference = json["reference"];
    if (json["types"] is List) {
      types = json["types"] == null ? null : List<String>.from(json["types"]);
    }
    if (json["user_ratings_total"] is int) userRatingsTotal = json["user_ratings_total"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["business_status"] = businessStatus;
    data["formatted_address"] = formattedAddress;
    if (geometry != null) data["geometry"] = geometry?.toJson();
    data["icon"] = icon;
    data["icon_background_color"] = iconBackgroundColor;
    data["icon_mask_base_uri"] = iconMaskBaseUri;
    data["name"] = name;
    if (openingHours != null) data["opening_hours"] = openingHours?.toJson();
    if (photos != null) data["photos"] = photos?.map((e) => e.toJson()).toList();
    data["place_id"] = placeId;
    if (plusCode != null) data["plus_code"] = plusCode?.toJson();
    data["price_level"] = priceLevel;
    data["rating"] = rating;
    data["reference"] = reference;
    if (types != null) data["types"] = types;
    data["user_ratings_total"] = userRatingsTotal;
    return data;
  }
}

class PlusCode {
  String? compoundCode;
  String? globalCode;

  PlusCode({this.compoundCode, this.globalCode});

  PlusCode.fromJson(Map<String, dynamic> json) {
    if (json["compound_code"] is String) compoundCode = json["compound_code"];
    if (json["global_code"] is String) globalCode = json["global_code"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["compound_code"] = compoundCode;
    data["global_code"] = globalCode;
    return data;
  }
}

class Photos {
  int? height;
  List<String>? htmlAttributions;
  String? photoReference;
  int? width;

  Photos({this.height, this.htmlAttributions, this.photoReference, this.width});

  Photos.fromJson(Map<String, dynamic> json) {
    if (json["height"] is int) height = json["height"];
    if (json["html_attributions"] is List) {
      htmlAttributions =
          json["html_attributions"] == null ? null : List<String>.from(json["html_attributions"]);
    }
    if (json["photo_reference"] is String) photoReference = json["photo_reference"];
    if (json["width"] is int) width = json["width"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["height"] = height;
    if (htmlAttributions != null) data["html_attributions"] = htmlAttributions;
    data["photo_reference"] = photoReference;
    data["width"] = width;
    return data;
  }
}

class OpeningHours {
  bool? openNow;

  OpeningHours({this.openNow});

  OpeningHours.fromJson(Map<String, dynamic> json) {
    if (json["open_now"] is bool) openNow = json["open_now"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["open_now"] = openNow;
    return data;
  }
}

class Geometry {
  LocationResultModel? location;
  Viewport? viewport;

  Geometry({this.location, this.viewport});

  Geometry.fromJson(Map<String, dynamic> json) {
    if (json["location"] is Map) {
      location = json["location"] == null ? null : LocationResultModel.fromJson(json["location"]);
    }
    if (json["viewport"] is Map) {
      viewport = json["viewport"] == null ? null : Viewport.fromJson(json["viewport"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (location != null) data["location"] = location?.toJson();
    if (viewport != null) data["viewport"] = viewport?.toJson();
    return data;
  }
}

class Viewport {
  Northeast? northeast;
  Southwest? southwest;

  Viewport({this.northeast, this.southwest});

  Viewport.fromJson(Map<String, dynamic> json) {
    if (json["northeast"] is Map) {
      northeast = json["northeast"] == null ? null : Northeast.fromJson(json["northeast"]);
    }
    if (json["southwest"] is Map) {
      southwest = json["southwest"] == null ? null : Southwest.fromJson(json["southwest"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (northeast != null) data["northeast"] = northeast?.toJson();
    if (southwest != null) data["southwest"] = southwest?.toJson();
    return data;
  }
}

class Southwest {
  double? lat;
  double? lng;

  Southwest({this.lat, this.lng});

  Southwest.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}

class Northeast {
  double? lat;
  double? lng;

  Northeast({this.lat, this.lng});

  Northeast.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}

class LocationResultModel {
  double? lat;
  double? lng;

  LocationResultModel({this.lat, this.lng});

  LocationResultModel.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}
