class SeachPlaceResultDetailModel {
  List<AddressComponents>? addressComponents;
  String? adrAddress;
  String? businessStatus;
  String? formattedAddress;
  String? formattedPhoneNumber;
  DetailGeometry? geometry;
  String? icon;
  String? iconBackgroundColor;
  String? iconMaskBaseUri;
  String? internationalPhoneNumber;
  String? name;
  DetailOpeningHours? openingHours;
  List<DetailPhotos>? photos;
  String? placeId;
  PlusCodeModel? plusCode;
  dynamic priceLevel;
  double? rating;
  String? reference;
  List<Reviews>? reviews;
  List<String>? types;
  String? url;
  dynamic userRatingsTotal;
  dynamic utcOffset;
  String? vicinity;
  String? website;

  SeachPlaceResultDetailModel(
      {this.addressComponents,
      this.adrAddress,
      this.businessStatus,
      this.formattedAddress,
      this.formattedPhoneNumber,
      this.geometry,
      this.icon,
      this.iconBackgroundColor,
      this.iconMaskBaseUri,
      this.internationalPhoneNumber,
      this.name,
      this.openingHours,
      this.photos,
      this.placeId,
      this.plusCode,
      this.priceLevel,
      this.rating,
      this.reference,
      this.reviews,
      this.types,
      this.url,
      this.userRatingsTotal,
      this.utcOffset,
      this.vicinity,
      this.website});

  String get street =>
      "${addressComponents?.any((e) => e.types?.contains('street_number') ?? false) ?? false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('street_number') ?? false)
                  .longName ??
              '')
          : ''} ${addressComponents?.any((e) => e.types?.contains('route') ?? false) ?? false
          ? (addressComponents?.firstWhere((e) => e.types?.contains('route') ?? false).longName ??
              '')
          : ''}";
  String get city =>
      addressComponents?.any((e) => e.types?.contains('administrative_area_level_2') ?? false) ??
              false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('administrative_area_level_2') ?? false)
                  .longName ??
              '')
          : '';
  String get state =>
      addressComponents?.any((e) => e.types?.contains('administrative_area_level_1') ?? false) ??
              false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('administrative_area_level_1') ?? false)
                  .longName ??
              '')
          : '';

  String get postalCode =>
      addressComponents?.any((e) => e.types?.contains('postal_code') ?? false) ?? false
          ? (addressComponents
                  ?.firstWhere((e) => e.types?.contains('postal_code') ?? false)
                  .longName ??
              '')
          : '';
  String get country => addressComponents?.any((e) => e.types?.contains('country') ?? false) ??
          false
      ? (addressComponents?.firstWhere((e) => e.types?.contains('country') ?? false).longName ?? '')
      : '';

  SeachPlaceResultDetailModel.fromJson(Map<String, dynamic> json) {
    if (json["address_components"] is List) {
      addressComponents = json["address_components"] == null
          ? null
          : (json["address_components"] as List).map((e) => AddressComponents.fromJson(e)).toList();
    }
    if (json["adr_address"] is String) adrAddress = json["adr_address"];
    if (json["business_status"] is String) businessStatus = json["business_status"];
    if (json["formatted_address"] is String) formattedAddress = json["formatted_address"];
    if (json["formatted_phone_number"] is String) {
      formattedPhoneNumber = json["formatted_phone_number"];
    }
    if (json["geometry"] is Map) {
      geometry = json["geometry"] == null ? null : DetailGeometry.fromJson(json["geometry"]);
    }
    if (json["icon"] is String) icon = json["icon"];
    if (json["icon_background_color"] is String) {
      iconBackgroundColor = json["icon_background_color"];
    }
    if (json["icon_mask_base_uri"] is String) iconMaskBaseUri = json["icon_mask_base_uri"];
    if (json["international_phone_number"] is String) {
      internationalPhoneNumber = json["international_phone_number"];
    }
    if (json["name"] is String) name = json["name"];
    if (json["opening_hours"] is Map) {
      openingHours =
          json["opening_hours"] == null ? null : DetailOpeningHours.fromJson(json["opening_hours"]);
    }
    if (json["photos"] is List) {
      photos = json["photos"] == null
          ? null
          : (json["photos"] as List).map((e) => DetailPhotos.fromJson(e)).toList();
    }
    if (json["place_id"] is String) placeId = json["place_id"];
    if (json["plus_code"] is Map) {
      plusCode = json["plus_code"] == null ? null : PlusCodeModel.fromJson(json["plus_code"]);
    }
    if (json["price_level"] is int) priceLevel = json["price_level"];
    if (json["rating"] is double) rating = json["rating"];
    if (json["reference"] is String) reference = json["reference"];
    if (json["reviews"] is List) {
      reviews = json["reviews"] == null
          ? null
          : (json["reviews"] as List).map((e) => Reviews.fromJson(e)).toList();
    }
    if (json["types"] is List) {
      types = json["types"] == null ? null : List<String>.from(json["types"]);
    }
    if (json["url"] is String) url = json["url"];
    if (json["user_ratings_total"] is int) userRatingsTotal = json["user_ratings_total"];
    if (json["utc_offset"] is int) utcOffset = json["utc_offset"];
    if (json["vicinity"] is String) vicinity = json["vicinity"];
    if (json["website"] is String) website = json["website"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (addressComponents != null) {
      data["address_components"] = addressComponents?.map((e) => e.toJson()).toList();
    }
    data["adr_address"] = adrAddress;
    data["business_status"] = businessStatus;
    data["formatted_address"] = formattedAddress;
    data["formatted_phone_number"] = formattedPhoneNumber;
    if (geometry != null) data["geometry"] = geometry?.toJson();
    data["icon"] = icon;
    data["icon_background_color"] = iconBackgroundColor;
    data["icon_mask_base_uri"] = iconMaskBaseUri;
    data["international_phone_number"] = internationalPhoneNumber;
    data["name"] = name;
    if (openingHours != null) data["opening_hours"] = openingHours?.toJson();
    if (photos != null) data["photos"] = photos?.map((e) => e.toJson()).toList();
    data["place_id"] = placeId;
    if (plusCode != null) data["plus_code"] = plusCode?.toJson();
    data["price_level"] = priceLevel;
    data["rating"] = rating;
    data["reference"] = reference;
    if (reviews != null) data["reviews"] = reviews?.map((e) => e.toJson()).toList();
    if (types != null) data["types"] = types;
    data["url"] = url;
    data["user_ratings_total"] = userRatingsTotal;
    data["utc_offset"] = utcOffset;
    data["vicinity"] = vicinity;
    data["website"] = website;
    return data;
  }
}

class Reviews {
  String? authorName;
  String? authorUrl;
  String? language;
  String? profilePhotoUrl;
  dynamic rating;
  String? relativeTimeDescription;
  String? text;
  dynamic time;

  Reviews(
      {this.authorName,
      this.authorUrl,
      this.language,
      this.profilePhotoUrl,
      this.rating,
      this.relativeTimeDescription,
      this.text,
      this.time});

  Reviews.fromJson(Map<String, dynamic> json) {
    if (json["author_name"] is String) authorName = json["author_name"];
    if (json["author_url"] is String) authorUrl = json["author_url"];
    if (json["language"] is String) language = json["language"];
    if (json["profile_photo_url"] is String) profilePhotoUrl = json["profile_photo_url"];
    if (json["rating"] is int) rating = json["rating"];
    if (json["relative_time_description"] is String) {
      relativeTimeDescription = json["relative_time_description"];
    }
    if (json["text"] is String) text = json["text"];
    if (json["time"] is int) time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["author_name"] = authorName;
    data["author_url"] = authorUrl;
    data["language"] = language;
    data["profile_photo_url"] = profilePhotoUrl;
    data["rating"] = rating;
    data["relative_time_description"] = relativeTimeDescription;
    data["text"] = text;
    data["time"] = time;
    return data;
  }
}

class PlusCodeModel {
  String? compoundCode;
  String? globalCode;

  PlusCodeModel({this.compoundCode, this.globalCode});

  PlusCodeModel.fromJson(Map<String, dynamic> json) {
    if (json["compound_code"] is String) compoundCode = json["compound_code"];
    if (json["global_code"] is String) globalCode = json["global_code"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["compound_code"] = compoundCode;
    data["global_code"] = globalCode;
    return data;
  }
}

class DetailPhotos {
  dynamic height;
  List<String>? htmlAttributions;
  String? photoReference;
  dynamic width;

  DetailPhotos({this.height, this.htmlAttributions, this.photoReference, this.width});

  DetailPhotos.fromJson(Map<String, dynamic> json) {
    if (json["height"] is int) height = json["height"];
    if (json["html_attributions"] is List) {
      htmlAttributions =
          json["html_attributions"] == null ? null : List<String>.from(json["html_attributions"]);
    }
    if (json["photo_reference"] is String) photoReference = json["photo_reference"];
    if (json["width"] is int) width = json["width"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["height"] = height;
    if (htmlAttributions != null) data["html_attributions"] = htmlAttributions;
    data["photo_reference"] = photoReference;
    data["width"] = width;
    return data;
  }
}

class DetailOpeningHours {
  bool? openNow;
  List<Periods>? periods;
  List<String>? weekdayText;

  DetailOpeningHours({this.openNow, this.periods, this.weekdayText});

  DetailOpeningHours.fromJson(Map<String, dynamic> json) {
    if (json["open_now"] is bool) openNow = json["open_now"];
    if (json["periods"] is List) {
      periods = json["periods"] == null
          ? null
          : (json["periods"] as List).map((e) => Periods.fromJson(e)).toList();
    }
    if (json["weekday_text"] is List) {
      weekdayText =
          json["weekday_text"] == null ? null : List<String>.from(json["weekday_text"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["open_now"] = openNow;
    if (periods != null) data["periods"] = periods?.map((e) => e.toJson()).toList();
    if (weekdayText != null) data["weekday_text"] = weekdayText;
    return data;
  }
}

class Periods {
  Close? close;
  Open? open;

  Periods({this.close, this.open});

  Periods.fromJson(Map<String, dynamic> json) {
    if (json["close"] is Map) {
      close = json["close"] == null ? null : Close.fromJson(json["close"]);
    }
    if (json["open"] is Map) open = json["open"] == null ? null : Open.fromJson(json["open"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (close != null) data["close"] = close?.toJson();
    if (open != null) data["open"] = open?.toJson();
    return data;
  }
}

class Open {
  dynamic day;
  String? time;

  Open({this.day, this.time});

  Open.fromJson(Map<String, dynamic> json) {
    if (json["day"] is int) day = json["day"];
    if (json["time"] is String) time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["day"] = day;
    data["time"] = time;
    return data;
  }
}

class Close {
  dynamic day;
  String? time;

  Close({this.day, this.time});

  Close.fromJson(Map<String, dynamic> json) {
    if (json["day"] is int) day = json["day"];
    if (json["time"] is String) time = json["time"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["day"] = day;
    data["time"] = time;
    return data;
  }
}

class DetailGeometry {
  DetailLocation? location;
  DetailViewport? viewport;

  DetailGeometry({this.location, this.viewport});

  DetailGeometry.fromJson(Map<String, dynamic> json) {
    if (json["location"] is Map) {
      location = json["location"] == null ? null : DetailLocation.fromJson(json["location"]);
    }
    if (json["viewport"] is Map) {
      viewport = json["viewport"] == null ? null : DetailViewport.fromJson(json["viewport"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (location != null) data["location"] = location?.toJson();
    if (viewport != null) data["viewport"] = viewport?.toJson();
    return data;
  }
}

class DetailViewport {
  DetailNortheast? northeast;
  DetailSouthwest? southwest;

  DetailViewport({this.northeast, this.southwest});

  DetailViewport.fromJson(Map<String, dynamic> json) {
    if (json["northeast"] is Map) {
      northeast =
          json["northeast"] == null ? null : DetailNortheast.fromJson(json["northeast"]);
    }
    if (json["southwest"] is Map) {
      southwest =
          json["southwest"] == null ? null : DetailSouthwest.fromJson(json["southwest"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (northeast != null) data["northeast"] = northeast?.toJson();
    if (southwest != null) data["southwest"] = southwest?.toJson();
    return data;
  }
}

class DetailSouthwest {
  double? lat;
  double? lng;

  DetailSouthwest({this.lat, this.lng});

  DetailSouthwest.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}

class DetailNortheast {
  double? lat;
  double? lng;

  DetailNortheast({this.lat, this.lng});

  DetailNortheast.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}

class DetailLocation {
  double? lat;
  double? lng;

  DetailLocation({this.lat, this.lng});

  DetailLocation.fromJson(Map<String, dynamic> json) {
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["lat"] = lat;
    data["lng"] = lng;
    return data;
  }
}

class AddressComponents {
  String? longName;
  String? shortName;
  List<String>? types;

  AddressComponents({this.longName, this.shortName, this.types});

  AddressComponents.fromJson(Map<String, dynamic> json) {
    if (json["long_name"] is String) longName = json["long_name"];
    if (json["short_name"] is String) shortName = json["short_name"];
    if (json["types"] is List) {
      types = json["types"] == null ? null : List<String>.from(json["types"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["long_name"] = longName;
    data["short_name"] = shortName;
    if (types != null) data["types"] = types;
    return data;
  }
}
