class DigicodeLogModel {
  int? id;
  int? digicodeId;
  String? productSerial;
  String? placeCity;
  String? placeLabel;
  int? placeLng;
  int? placeLat;
  String? placeCountry;
  String? placeZip;
  String? placeStreet1;
  String? placeStreet2;
  String? code;
  int? typedAt;
  int? success;
  int? display;
  int? manualUnlock;
  String? digicodeName;
  String? labelTyper;
  String? publicName;
  String? utcModifier;

  DigicodeLogModel(
      {this.id,
      this.digicodeId,
      this.productSerial,
      this.placeCity,
      this.placeLabel,
      this.placeLng,
      this.placeLat,
      this.placeCountry,
      this.placeZip,
      this.placeStreet1,
      this.placeStreet2,
      this.code,
      this.typedAt,
      this.success,
      this.display,
      this.manualUnlock,
      this.digicodeName,
      this.labelTyper,
      this.publicName,
      this.utcModifier});

  String address() =>
      ((placeStreet1 ?? '').isNotEmpty ? "$placeStreet1, " : "") +
      ((placeCity ?? '').isNotEmpty ? "$placeCity, " : "") +
      (placeCountry ?? '');

  DigicodeLogModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["digicodeId"] is int) digicodeId = json["digicodeId"];
    if (json["productSerial"] is String) {
      productSerial = json["productSerial"];
    }
    if (json["placeCity"] is String) placeCity = json["placeCity"];
    if (json["placeLabel"] is String) placeLabel = json["placeLabel"];
    if (json["placeLng"] is int) placeLng = json["placeLng"];
    if (json["placeLat"] is int) placeLat = json["placeLat"];
    if (json["placeCountry"] is String) {
      placeCountry = json["placeCountry"];
    }
    if (json["placeZip"] is String) placeZip = json["placeZip"];
    if (json["placeStreet1"] is String) {
      placeStreet1 = json["placeStreet1"];
    }
    if (json["placeStreet2"] is String) {
      placeStreet2 = json["placeStreet2"];
    }
    if (json["code"] is String) code = json["code"];
    if (json["typedAt"] is int) typedAt = json["typedAt"];
    if (json["success"] is int) success = json["success"];
    if (json["display"] is int) display = json["display"];
    if (json["manualUnlock"] is int) manualUnlock = json["manualUnlock"];
    if (json["digicodeName"] is String) {
      digicodeName = json["digicodeName"];
    }
    if (json["labelTyper"] is String) labelTyper = json["labelTyper"];
    if (json["publicName"] is String) publicName = json["publicName"];
    if (json["utcModifier"] is String) utcModifier = json["utcModifier"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["digicodeId"] = digicodeId;
    data["productSerial"] = productSerial;
    data["placeCity"] = placeCity;
    data["placeLabel"] = placeLabel;
    data["placeLng"] = placeLng;
    data["placeLat"] = placeLat;
    data["placeCountry"] = placeCountry;
    data["placeZip"] = placeZip;
    data["placeStreet1"] = placeStreet1;
    data["placeStreet2"] = placeStreet2;
    data["code"] = code;
    data["typedAt"] = typedAt;
    data["success"] = success;
    data["display"] = display;
    data["manualUnlock"] = manualUnlock;
    data["digicodeName"] = digicodeName;
    data["labelTyper"] = labelTyper;
    data["publicName"] = publicName;
    data["utcModifier"] = utcModifier;
    return data;
  }
}
