class DigicodeModel {
  String? digicodeLabel;
  String? description;
  int? id;
  String? authCode;
  int? unlocked;
  int? activeCamera;
  String? publicName;
  int? productId;
  int? purchasedAt;
  int? warrantyUntil;
  String? productSerial;
  String? statusLabel;
  String? statusColor;
  String? productRef;
  String? pictureUrl;
  String? productCat;
  int? productDisplay;
  String? productColor;
  int? placeId;
  String? utcModifier;
  String? placeCity;
  String? placeLabel;
  double? placeLng;
  double? placeLat;
  String? placeCountry;
  String? placeCountryCode;
  String? placeZip;
  String? placeStreet1;
  String? placeStreet2;
  String? roomId;
  String? roomName;

  DigicodeModel(
      {this.digicodeLabel,
      this.description,
      this.id,
      this.authCode,
      this.unlocked,
      this.activeCamera,
      this.publicName,
      this.productId,
      this.purchasedAt,
      this.warrantyUntil,
      this.productSerial,
      this.statusLabel,
      this.statusColor,
      this.productRef,
      this.pictureUrl,
      this.productCat,
      this.productDisplay,
      this.productColor,
      this.placeId,
      this.utcModifier,
      this.placeCity,
      this.placeLabel,
      this.placeLng,
      this.placeLat,
      this.placeCountry,
      this.placeCountryCode,
      this.placeZip,
      this.placeStreet1,
      this.placeStreet2,
      this.roomId,
      this.roomName});
      
  String address() =>
      ((placeStreet1 ?? '').isNotEmpty ? "$placeStreet1, " : "") +
      ((placeCity ?? '').isNotEmpty ? "$placeCity, " : "") +
      (placeCountry ?? '');

  DigicodeModel.fromJson(Map<String, dynamic> json) {
    if (json["digicodeLabel"] is String) {
      digicodeLabel = json["digicodeLabel"];
    }
    if (json["description"] is String) description = json["description"];
    if (json["id"] is int) id = json["id"];
    if (json["authCode"] is String) authCode = json["authCode"];
    if (json["unlocked"] is int) unlocked = json["unlocked"];
    if (json["activeCamera"] is int) activeCamera = json["activeCamera"];
    if (json["publicName"] is String) publicName = json["publicName"];
    if (json["productId"] is int) productId = json["productId"];
    if (json["purchasedAt"] is int) purchasedAt = json["purchasedAt"];
    if (json["warrantyUntil"] is int) {
      warrantyUntil = json["warrantyUntil"];
    }
    if (json["productSerial"] is String) {
      productSerial = json["productSerial"];
    }
    if (json["statusLabel"] is String) statusLabel = json["statusLabel"];
    if (json["statusColor"] is String) statusColor = json["statusColor"];
    if (json["productRef"] is String) productRef = json["productRef"];
    if (json["pictureUrl"] is String) pictureUrl = json["pictureUrl"];
    if (json["productCat"] is String) productCat = json["productCat"];
    if (json["productDisplay"] is int) {
      productDisplay = json["productDisplay"];
    }
    if (json["productColor"] is String) {
      productColor = json["productColor"];
    }
    if (json["placeId"] is int) placeId = json["placeId"];
    if (json["utcModifier"] is String) utcModifier = json["utcModifier"];
    if (json["placeCity"] is String) placeCity = json["placeCity"];
    if (json["placeLabel"] is String) placeLabel = json["placeLabel"];
    if (json["placeLng"] is double) placeLng = json["placeLng"];
    if (json["placeLat"] is double) placeLat = json["placeLat"];
    if (json["placeCountry"] is String) {
      placeCountry = json["placeCountry"];
    }
    if (json["placeCountryCode"] is String) {
      placeCountryCode = json["placeCountryCode"];
    }
    if (json["placeZip"] is String) placeZip = json["placeZip"];
    if (json["placeStreet1"] is String) {
      placeStreet1 = json["placeStreet1"];
    }
    if (json["placeStreet2"] is String) {
      placeStreet2 = json["placeStreet2"];
    }
    if (json["roomId"] is String) roomId = json["roomId"];
    if (json["roomName"] is String) roomName = json["roomName"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["digicodeLabel"] = digicodeLabel;
    data["description"] = description;
    data["id"] = id;
    data["authCode"] = authCode;
    data["unlocked"] = unlocked;
    data["activeCamera"] = activeCamera;
    data["publicName"] = publicName;
    data["productId"] = productId;
    data["purchasedAt"] = purchasedAt;
    data["warrantyUntil"] = warrantyUntil;
    data["productSerial"] = productSerial;
    data["statusLabel"] = statusLabel;
    data["statusColor"] = statusColor;
    data["productRef"] = productRef;
    data["pictureUrl"] = pictureUrl;
    data["productCat"] = productCat;
    data["productDisplay"] = productDisplay;
    data["productColor"] = productColor;
    data["placeId"] = placeId;
    data["utcModifier"] = utcModifier;
    data["placeCity"] = placeCity;
    data["placeLabel"] = placeLabel;
    data["placeLng"] = placeLng;
    data["placeLat"] = placeLat;
    data["placeCountry"] = placeCountry;
    data["placeCountryCode"] = placeCountryCode;
    data["placeZip"] = placeZip;
    data["placeStreet1"] = placeStreet1;
    data["placeStreet2"] = placeStreet2;
    data["roomId"] = roomId;
    data["roomName"] = roomName;
    return data;
  }
}
