class MoveModel {
  int? id;
  String? title;
  String? slug;
  dynamic content;
  String? address;
  String? video;
  double? lat;
  double? lng;
  dynamic distance;
  int? isFeatured;
  int? priceRange;
  int? reviewScore;
  dynamic logoUrl;
  dynamic qrCode;
  String? image;
  String? bannerImage;
  List<String>? gallery;
  MoviCategory? category;

  MoveModel(
      {this.id,
      this.title,
      this.slug,
      this.content,
      this.address,
      this.video,
      this.lat,
      this.lng,
      this.distance,
      this.isFeatured,
      this.priceRange,
      this.reviewScore,
      this.logoUrl,
      this.qrCode,
      this.image,
      this.bannerImage,
      this.gallery,
      this.category});

  MoveModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["title"] is String) title = json["title"];
    if (json["slug"] is String) slug = json["slug"];
    content = json["content"];
    if (json["address"] is String) address = json["address"];
    if (json["video"] is String) video = json["video"];
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
    distance = json["distance"];
    if (json["isFeatured"] is int) isFeatured = json["isFeatured"];
    if (json["priceRange"] is int) priceRange = json["priceRange"];
    if (json["reviewScore"] is int) reviewScore = json["reviewScore"];
    logoUrl = json["logoUrl"];
    qrCode = json["qrCode"];
    if (json["image"] is String) image = json["image"];
    if (json["bannerImage"] is String) bannerImage = json["bannerImage"];
    if (json["gallery"] is List) {
      gallery =
          json["gallery"] == null ? null : List<String>.from(json["gallery"]);
    }
    if (json["category"] is Map) {
      category = json["category"] == null
          ? null
          : MoviCategory.fromJson(json["category"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["title"] = title;
    data["slug"] = slug;
    data["content"] = content;
    data["address"] = address;
    data["video"] = video;
    data["lat"] = lat;
    data["lng"] = lng;
    data["distance"] = distance;
    data["isFeatured"] = isFeatured;
    data["priceRange"] = priceRange;
    data["reviewScore"] = reviewScore;
    data["logoUrl"] = logoUrl;
    data["qrCode"] = qrCode;
    data["image"] = image;
    data["bannerImage"] = bannerImage;
    if (gallery != null) data["gallery"] = gallery;
    if (category != null) data["category"] = category?.toJson();
    return data;
  }
}

class MoviCategory {
  int? id;
  String? name;

  MoviCategory({this.id, this.name});

  MoviCategory.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["name"] is String) name = json["name"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["name"] = name;
    return data;
  }
}
