class PaymentCardStripe {
  int? cardId;
  String? paymentCardId;
  String? cardHolderName;
  String? cardBrand;
  int? cardExpMonth;
  int? cardExpYear;
  String? cardLast4;
  int? timestamp;
  String? gateway;
  String? cardNumber;
  String? cardCVC;
  late bool setAsDefault;

  double positionY = 0;
  double rotate = 0;
  double scale = 0;
  bool isNewCard = false;

  PaymentCardStripe(
      {this.cardId,
      this.paymentCardId,
      this.cardHolderName,
      this.cardBrand,
      this.cardExpMonth,
      this.cardExpYear,
      this.cardLast4,
      this.timestamp,
      this.gateway,
      this.cardNumber,
      this.cardCVC,
      this.setAsDefault = false,
      this.isNewCard = false});

  PaymentCardStripe.fromJson(Map<String, dynamic> json) {
    cardId = json['cardId'];
    paymentCardId = json['paymentCardId'];
    cardHolderName = json['cardHolderName'] ?? '';
    cardBrand = json['cardBrand'] ?? '';
    cardExpMonth = json['cardExpMonth'];
    cardExpYear = json['cardExpYear'];
    if (cardExpYear! > 2000) {
      cardExpYear = cardExpYear! % 2000;
    }
    cardLast4 = json['cardLast4'];
    timestamp = json['timestamp'];
    gateway = json['gateway'];
    cardNumber = json['cardNumber'];
    cardCVC = json['cardCVC'];
    setAsDefault = json['setAsDefault'] == 1;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['cardId'] = cardId;
    data['paymentCardId'] = paymentCardId;
    data['cardHolderName'] = cardHolderName;
    data['cardBrand'] = cardBrand;
    data['cardExpMonth'] = cardExpMonth;
    data['cardExpYear'] = cardExpYear;
    data['cardLast4'] = cardLast4;
    data['timestamp'] = timestamp;
    data['gateway'] = gateway;
    data['setAsDefault'] = setAsDefault;
    return data;
  }

  Map<String, dynamic> toJsonForAdd() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['cardHolderName'] = cardHolderName;
    data['cardExpMonth'] = cardExpMonth;
    data['cardExpYear'] = cardExpYear;
    data['cardNumber'] = cardNumber;
    data['cardCVC'] = cardCVC;
    data['setAsDefault'] = setAsDefault;
    return data;
  }
}
