class PlaceModel {
  String? street1;
  String? street2;
  String? zip;
  String? city;
  String? state;
  String? country;
  String? countryCode;
  String? informations;
  String? phone;
  String? phoneCode;
  int? placeCatId;
  int? arckipel;
  double? lng;
  double? lat;
  String? utcModifier;
  int? id;
  String? label;
  String? uniqueId;
  int? isBilling;
  int? isDefault;

  PlaceModel({
    this.street1,
    this.street2,
    this.zip,
    this.city,
    this.state,
    this.country,
    this.countryCode,
    this.informations,
    this.phone,
    this.phoneCode,
    this.placeCatId,
    this.arckipel,
    this.lng,
    this.lat,
    this.utcModifier,
    this.id,
    this.label,
    this.uniqueId,
    this.isBilling,
    this.isDefault,
  });

  PlaceModel.fromJson(Map<String, dynamic> json) {
    if (json["street1"] is String) street1 = json["street1"];
    if (json["street2"] is String) street2 = json["street2"];
    if (json["zip"] is String) zip = json["zip"];
    if (json["city"] is String) city = json["city"];
    if (json["state"] is String) state = json["state"];
    if (json["country"] is String) country = json["country"];
    if (json["countryCode"] is String) countryCode = json["countryCode"];
    if (json["informations"] is String) {
      informations = json["informations"];
    }
    if (json["phone"] is String) phone = json["phone"];
    if (json["phoneCode"] is String) phoneCode = json["phoneCode"];
    if (json["placeCatId"] is int) placeCatId = json["placeCatId"];
    if (json["arckipel"] is int) arckipel = json["arckipel"];
    if (json["lng"] is double) lng = json["lng"];
    if (json["lat"] is double) lat = json["lat"];
    if (json["utcModifier"] is String) utcModifier = json["utcModifier"];
    if (json["id"] is int) id = json["id"];
    if (json["label"] is String) label = json["label"];
    if (json["uniqueId"] is String) uniqueId = json["uniqueId"];
    if (json["isBilling"] is int) isBilling = json["isBilling"];
    if (json["isDefault"] is int) isDefault = json["isDefault"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["street1"] = street1;
    data["street2"] = street2;
    data["zip"] = zip;
    data["city"] = city;
    data["state"] = state;
    data["country"] = country;
    data["countryCode"] = countryCode;
    data["informations"] = informations;
    data["phone"] = phone;
    data["phoneCode"] = phoneCode;
    data["placeCatId"] = placeCatId;
    data["arckipel"] = arckipel;
    data["lng"] = lng;
    data["lat"] = lat;
    data["utcModifier"] = utcModifier;
    data["id"] = id;
    data["label"] = label;
    data["uniqueId"] = uniqueId;
    data["isBilling"] = isBilling;
    data["isDefault"] = isDefault;
    return data;
  }

  String toAddressString() {
    return ((street1 ?? '').isNotEmpty ? "$street1, " : "") +
        ((city ?? '').isNotEmpty ? "$city, " : "") +
        (country ?? '');
  }

  String toAddress2String() {
    if ((zip ?? "").isNotEmpty) {
      return '$street1\n$zip $city\n$country';
    } else {
      return '$street1\n$city\n$country';
    }
  }
}

class PlaceCatModel {
  int? catLocId;
  int? catId;
  String? local;
  String? localisedName;
  int? privacyEnforced;

  PlaceCatModel(
      {this.catLocId,
      this.catId,
      this.local,
      this.localisedName,
      this.privacyEnforced});

  PlaceCatModel.fromJson(Map<String, dynamic> json) {
    if (json["catLocId"] is int) catLocId = json["catLocId"];
    if (json["catId"] is int) catId = json["catId"];
    if (json["local"] is String) local = json["local"];
    if (json["localisedName"] is String) {
      localisedName = json["localisedName"];
    }
    if (json["privacyEnforced"] is int) {
      privacyEnforced = json["privacyEnforced"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["catLocId"] = catLocId;
    data["catId"] = catId;
    data["local"] = local;
    data["localisedName"] = localisedName;
    data["privacyEnforced"] = privacyEnforced;
    return data;
  }
}
