class PlaylistItemModel {
  int? id;
  String? label;
  String? value;
  int? duration;
  int? itemOrder;
  int? playlistId;
  int? audio;
  ContentType? contentType;

  PlaylistItemModel(
      {this.id,
      this.label,
      this.value,
      this.duration,
      this.itemOrder,
      this.playlistId,
      this.audio,
      this.contentType});

  PlaylistItemModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["label"] is String) label = json["label"];
    if (json["value"] is String) value = json["value"];
    if (json["duration"] is int) duration = json["duration"];
    if (json["itemOrder"] is int) itemOrder = json["itemOrder"];
    if (json["playlistId"] is int) playlistId = json["playlistId"];
    if (json["audio"] is int) audio = json["audio"];
    if (json["contentType"] is Map) {
      contentType = json["contentType"] == null
          ? null
          : ContentType.fromJson(json["contentType"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["label"] = label;
    data["value"] = value;
    data["duration"] = duration;
    data["itemOrder"] = itemOrder;
    data["playlistId"] = playlistId;
    data["audio"] = audio;
    if (contentType != null) {
      data["contentType"] = contentType?.toJson();
    }
    return data;
  }
}

class ContentType {
  int? id;
  String? label;

  ContentType({this.id, this.label});

  ContentType.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["label"] is String) label = json["label"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["label"] = label;
    return data;
  }
}
