class PmbDevice {
  String? id;
  String? serial;
  String? label;
  dynamic publicName;
  dynamic purchasedAt;
  dynamic warrantyUntil;
  String? qrCodeDevice;
  double? lat;
  double? lng;
  int? closeOpenSchedule;
  int? readyToPour;
  int? amountRent;
  int? amountBuy;
  String? currency;
  int? width;
  int? height;
  int? depth;
  int? numberOfPumps;
  int? debitPerSec;
  int? distance;
  List<Beers>? beers;

  PmbDevice(
      {this.id,
      this.serial,
      this.label,
      this.publicName,
      this.purchasedAt,
      this.warrantyUntil,
      this.qrCodeDevice,
      this.lat,
      this.lng,
      this.closeOpenSchedule,
      this.readyToPour,
      this.amountRent,
      this.amountBuy,
      this.currency,
      this.width,
      this.height,
      this.depth,
      this.numberOfPumps,
      this.debitPerSec,
      this.distance,
      this.beers});

  PmbDevice.fromJson(Map<String, dynamic> json) {
    if (json["id"] is String) id = json["id"];
    if (json["serial"] is String) serial = json["serial"];
    if (json["label"] is String) label = json["label"];
    publicName = json["publicName"];
    purchasedAt = json["purchasedAt"];
    warrantyUntil = json["warrantyUntil"];
    if (json["qrCodeDevice"] is String) {
      qrCodeDevice = json["qrCodeDevice"];
    }
    if (json["lat"] is double) lat = json["lat"];
    if (json["lng"] is double) lng = json["lng"];
    if (json["closeOpenSchedule"] is int) {
      closeOpenSchedule = json["closeOpenSchedule"];
    }
    if (json["readyToPour"] is int) readyToPour = json["readyToPour"];
    if (json["amountRent"] is int) amountRent = json["amountRent"];
    if (json["amountBuy"] is int) amountBuy = json["amountBuy"];
    if (json["currency"] is String) currency = json["currency"];
    if (json["width"] is int) width = json["width"];
    if (json["height"] is int) height = json["height"];
    if (json["depth"] is int) depth = json["depth"];
    if (json["numberOfPumps"] is int) {
      numberOfPumps = json["numberOfPumps"];
    }
    if (json["debitPerSec"] is int) debitPerSec = json["debitPerSec"];
    if (json["distance"] is int) distance = json["distance"];
    if (json["beers"] is List) {
      beers = json["beers"] == null
          ? null
          : (json["beers"] as List).map((e) => Beers.fromJson(e)).toList();
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["serial"] = serial;
    data["label"] = label;
    data["publicName"] = publicName;
    data["purchasedAt"] = purchasedAt;
    data["warrantyUntil"] = warrantyUntil;
    data["qrCodeDevice"] = qrCodeDevice;
    data["lat"] = lat;
    data["lng"] = lng;
    data["closeOpenSchedule"] = closeOpenSchedule;
    data["readyToPour"] = readyToPour;
    data["amountRent"] = amountRent;
    data["amountBuy"] = amountBuy;
    data["currency"] = currency;
    data["width"] = width;
    data["height"] = height;
    data["depth"] = depth;
    data["numberOfPumps"] = numberOfPumps;
    data["debitPerSec"] = debitPerSec;
    data["distance"] = distance;
    if (beers != null) {
      data["beers"] = beers?.map((e) => e.toJson()).toList();
    }
    return data;
  }
}

class Beers {
  String? logoUrl;
  String? id;
  double? alcoholPourcentage;
  dynamic biterOnTen;
  String? description;
  String? name;
  int? colorId;
  dynamic videoUrl;
  String? colorName;
  double? salePriceByLiter;
  String? currency;
  double? arckipelToken;

  Beers({
    this.logoUrl,
    this.id,
    this.alcoholPourcentage,
    this.biterOnTen,
    this.description,
    this.name,
    this.colorId,
    this.videoUrl,
    this.colorName,
    this.salePriceByLiter,
    this.currency,
    this.arckipelToken,
  });

  Beers.fromJson(Map<String, dynamic> json) {
    if (json["logoUrl"] is String) logoUrl = json["logoUrl"];
    if (json["id"] is String) id = json["id"];
    if (json["alcoholPourcentage"] is double) {
      alcoholPourcentage = json["alcoholPourcentage"];
    }
    biterOnTen = json["biterOnTen"];
    if (json["description"] is String) description = json["description"];
    if (json["name"] is String) name = json["name"];
    if (json["colorId"] is int) colorId = json["colorId"];
    videoUrl = json["videoUrl"];
    if (json["colorName"] is String) colorName = json["colorName"];
    if (json["salePriceByLiter"] is double) {
      salePriceByLiter = json["salePriceByLiter"];
    }
    if (json["currency"] is String) currency = json["currency"];
    if (json["arckipelToken"] is double) {
      arckipelToken = json["arckipelToken"];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["logoUrl"] = logoUrl;
    data["id"] = id;
    data["alcoholPourcentage"] = alcoholPourcentage;
    data["biterOnTen"] = biterOnTen;
    data["description"] = description;
    data["name"] = name;
    data["colorId"] = colorId;
    data["videoUrl"] = videoUrl;
    data["colorName"] = colorName;
    data["salePriceByLiter"] = salePriceByLiter;
    data["currency"] = currency;
    data["arckipelToken"] = arckipelToken;
    return data;
  }
}
