class TrackingInfoModel {
  int? id;
  int? allowedTimeBeforeTrack;
  double? allowedDistanceBeforeTrack;
  int? manualStatus;
  _UserInfo? userInfo;
  _ProInfo? proInfo;

  TrackingInfoModel(
      {this.id,
      this.allowedTimeBeforeTrack,
      this.allowedDistanceBeforeTrack,
      this.manualStatus,
      this.userInfo,
      this.proInfo});

  TrackingInfoModel.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["allowedTimeBeforeTrack"] is int) {
      allowedTimeBeforeTrack = json["allowedTimeBeforeTrack"];
    }
    if (json["allowedDistanceBeforeTrack"] is double) {
      allowedDistanceBeforeTrack = json["allowedDistanceBeforeTrack"];
    }
    if (json["manualStatus"] is int) manualStatus = json["manualStatus"];
    if (json["userInfo"] is Map) {
      userInfo =
          json["userInfo"] == null ? null : _UserInfo.fromJson(json["userInfo"]);
    }
    if (json["proInfo"] is Map) {
      proInfo =
          json["proInfo"] == null ? null : _ProInfo.fromJson(json["proInfo"]);
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["allowedTimeBeforeTrack"] = allowedTimeBeforeTrack;
    data["allowedDistanceBeforeTrack"] = allowedDistanceBeforeTrack;
    data["manualStatus"] = manualStatus;
    if (userInfo != null) data["userInfo"] = userInfo?.toJson();
    if (proInfo != null) data["proInfo"] = proInfo?.toJson();
    return data;
  }
}

class _ProInfo {
  int? id;
  String? firebaseId;

  _ProInfo();

  _ProInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["firebaseId"] is String) firebaseId = json["firebaseId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["firebaseId"] = firebaseId;
    return data;
  }
}

class _UserInfo {
  int? id;
  String? firebaseId;

  _UserInfo();

  _UserInfo.fromJson(Map<String, dynamic> json) {
    if (json["id"] is int) id = json["id"];
    if (json["firebaseId"] is String) firebaseId = json["firebaseId"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["firebaseId"] = firebaseId;
    return data;
  }
}
