class PaymentBillingInfo {
  String? billingName;
  String? street;
  String? zip;
  String? city;
  String? state;
  String? country;
  String? countryCode;
  String? companyName;
  String? vat;
  String? companyNumber;
  String? currency;
  int? id;
  int? isDefault;
  int? createdAt;
  int? updatedAt;

  PaymentBillingInfo(
      {this.billingName,
      this.street,
      this.zip,
      this.city,
      this.state,
      this.country,
      this.countryCode,
      this.companyName,
      this.vat,
      this.companyNumber,
      this.currency,
      this.id,
      this.isDefault,
      this.createdAt,
      this.updatedAt});

  PaymentBillingInfo.fromJson(Map<String, dynamic> json) {
    billingName = json["billingName"];
    street = json["street"];
    zip = json["zip"];
    city = json["city"];
    state = json["state"];
    country = json["country"];
    countryCode = json["countryCode"];
    companyName = json["companyName"];
    vat = json["VAT"];
    companyNumber = json["companyNumber"];
    currency = json["currency"];
    id = json["id"];
    isDefault = json["isDefault"];
    createdAt = json["createdAt"];
    updatedAt = json["updatedAt"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["billingName"] = billingName;
    data["street"] = street;
    data["zip"] = zip;
    data["city"] = city;
    data["state"] = state;
    data["country"] = country;
    data["countryCode"] = countryCode;
    data["companyName"] = companyName;
    data["VAT"] = vat;
    data["companyNumber"] = companyNumber;
    data["currency"] = currency;
    data["id"] = id;
    data["isDefault"] = isDefault;
    data["createdAt"] = createdAt;
    data["updatedAt"] = updatedAt;
    return data;
  } 
}
