import '../resources.dart';

class PaymentRepo {
  PaymentRepo._();

  static PaymentRepo? _instance;

  factory PaymentRepo([AppApi? api]) {
    _instance ??= PaymentRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<List<PaymentCardStripe>> getCustomerCardsStripe(page, pageSize) async {
    NetworkResponse response =
        await _api.getCustomerCardsStripe(page, pageSize);
    return response.data ?? [];
  }

  Future<PaymentCardStripe?> createCustomerCardStripe(params) async {
    NetworkResponse response = await _api.createCustomerCardStripe(params);
    return response.data;
  }

  Future<NetworkResponse> createCustomerCardStripe2(params) async {
    return await _api.createCustomerCardStripe(params);
  }

  Future<bool> deleteCustomerCardStripe(cardId) async {
    NetworkResponse response = await _api.deleteCustomerCardStripe(cardId);
    return response.data ?? false;
  }

  Future<bool> setCustomerCardDefaultStripe(cardId) async {
    NetworkResponse response = await _api.setCustomerCardDefaultStripe(cardId);
    return response.data ?? false;
  }

  Future<WalletInfo?> getWalletInfo() async {
    NetworkResponse response = await _api.getWalletInfo();
    return response.data;
  }

  Future<List<PaymentInfoModel>> createPurchaseByCardOnFileStripe(
      PaymentRequestModel request) async {
    // var params = {
    //   'purchaseType': 90,
    //   'currency': currency,
    //   'tokenType': tokenType,
    //   'priceByUnit': priceByUnit,
    //   'amount': amount,
    //   'cardId': cardId,
    // };
    NetworkResponse response =
        await _api.createPurchaseByCardOnFileStripe(request.toJson());
    return response.data ?? [];
  }

  Future<bool> updateOrderDetailsByAdmin(cardId) async {
    NetworkResponse response = await _api.updateOrderDetailsByAdmin(cardId);
    return response.data ?? false;
  }

  Future<List<PaymentMethod>> getPaymentMethodList(params) async {
    NetworkResponse response = await _api.getPaymentMethodList(params);
    return response.data ?? [];
  }

  Future<List<PaymentStatus>> getPaymentStatusList(params) async {
    NetworkResponse response = await _api.getPaymentStatusList(params);
    return response.data ?? [];
  }

  Future<List<PaymentOrder>> getOrdersFromProOrUser(params) async {
    NetworkResponse response = await _api.getOrdersFromProOrUser(params);
    return response.data ?? [];
  }

  Future<List<PaymentOrder>> getOrdersFromAdmin(params) async {
    NetworkResponse response = await _api.getOrdersFromAdmin(params);
    return response.data ?? [];
  }
 
}
